// Menu_Water.cpp : implementation file
//

#include "../../Source/MFC_Core/stdafx.h"
#include "../../Source/MFC_Core/MapTool_3D.h"
#include "Menu_Water.h"


// CMenu_Water dialog

IMPLEMENT_DYNAMIC(CMenu_Water, CDialog)

CMenu_Water::CMenu_Water(CWnd* pParent /*=NULL*/)
	: CDialog(CMenu_Water::IDD, pParent)
	, m_OceanMap_Width(256)
	, m_OceanMap_Height(256)
	, m_Ocean_Pos_X(0)
	, m_Ocean_Pos_Y(108)
	, m_Ocean_Pos_Z(0)

	, m_Ocean_waveFreq(0.028f)
	, m_Ocean_waveAmp(1.8f)
	, m_Ocean_bumpscale(0.2f)
	, m_Ocean_bumpSpeed_X(0.015f)
	, m_Ocean_bumpSpeed_Y(0.005f)

	, m_Ocean_DeepColor_R(0.0f)
	, m_Ocean_DeepColor_G(0.03f)
	, m_Ocean_DeepColor_B(0.05f)
	, m_Ocean_DeepColor_A(1.0f)

	, m_Ocean_shallowcolor_R(0.0f)
	, m_Ocean_shallowcolor_G(0.5f)
	, m_Ocean_shallowcolor_B(0.5f)
	, m_Ocean_shallowcolor_A(1.0f)

	, m_Ocean_reflectcolor_R(0.95f)
	, m_Ocean_reflectcolor_G(1.0f)
	, m_Ocean_reflectcolor_B(1.0f)
	, m_Ocean_reflectcolor_A(1.0f)

	, m_Ocean_reflectAmount(1.0f)
	, m_Ocean_reflectBlur(0.0f)
	, m_Ocean_FresenlPow(5.0f)
	, m_Ocean_FresenlBias(0.328f)
	, m_Ocean_hdrMulti(0.471f)

	, m_Ocean_Texture_W(25.0f)
	, m_Ocean_Texture_H(26.0f)
{
	g_Option._Ocean.waveFreq = m_Ocean_waveFreq;
	g_Option._Ocean.waveAmp = m_Ocean_waveAmp;
	g_Option._Ocean.bumpscale = m_Ocean_bumpscale;
	g_Option._Ocean.trxtureScale.x = m_Ocean_Texture_W;
	g_Option._Ocean.trxtureScale.y = m_Ocean_Texture_H;
	
	g_Option._Ocean.AlphaLayer = true;
	g_Option._Ocean._using = true;
	
	g_Option._Ocean.bumpspeed.x = m_Ocean_bumpSpeed_X;
	g_Option._Ocean.bumpspeed.y = m_Ocean_bumpSpeed_Y;

	g_Option._Ocean.deepcolor.x = m_Ocean_DeepColor_R;
	g_Option._Ocean.deepcolor.y = m_Ocean_DeepColor_G;
	g_Option._Ocean.deepcolor.z = m_Ocean_DeepColor_B;
	g_Option._Ocean.deepcolor.w = m_Ocean_DeepColor_A;

	g_Option._Ocean.shallowcolor.x = m_Ocean_shallowcolor_R;
	g_Option._Ocean.shallowcolor.y = m_Ocean_shallowcolor_G;
	g_Option._Ocean.shallowcolor.z = m_Ocean_shallowcolor_B;
	g_Option._Ocean.shallowcolor.w = m_Ocean_shallowcolor_A;
	
	g_Option._Ocean.reflectcolor.x = m_Ocean_reflectcolor_R;
	g_Option._Ocean.reflectcolor.y = m_Ocean_reflectcolor_G;
	g_Option._Ocean.reflectcolor.z = m_Ocean_reflectcolor_B;
	g_Option._Ocean.reflectcolor.w = m_Ocean_reflectcolor_A;

	g_Option._Ocean.reflactamount = m_Ocean_reflectAmount;
	g_Option._Ocean.reflactblur = m_Ocean_reflectBlur;
	g_Option._Ocean.fresenlpow = m_Ocean_FresenlPow;
	g_Option._Ocean.fresenlbias = m_Ocean_FresenlBias;
	g_Option._Ocean.hdrMulti = m_Ocean_hdrMulti;

	g_Option._Ocean.OceanSize_W = m_OceanMap_Width;
	g_Option._Ocean.OceanSize_H = m_OceanMap_Height;

	g_Option._Ocean.Position.x = m_Ocean_Pos_X;
	g_Option._Ocean.Position.y = m_Ocean_Pos_Y;
	g_Option._Ocean.Position.z = m_Ocean_Pos_Z;	
}

CMenu_Water::~CMenu_Water()
{
}

void CMenu_Water::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_C_OCEAN_USE, m_Ocean_Use);
	DDX_Control(pDX, IDC_C_OCEAN_TRANS, m_Ocean_Trans);
	DDX_Text(pDX, IDC_I_OCEANSIZE_W, m_OceanMap_Width);
	DDV_MinMaxInt(pDX, m_OceanMap_Width, 4, 1024);
	DDX_Text(pDX, IDC_I_OCEANSIZE_H, m_OceanMap_Height);
	DDV_MinMaxInt(pDX, m_OceanMap_Height, 4, 1024);
	DDX_Text(pDX, IDC_I_OCEAN_POSX, m_Ocean_Pos_X);
	DDV_MinMaxFloat(pDX, m_Ocean_Pos_X, -255.0, 255.0);
	DDX_Text(pDX, IDC_I_OCEAN_POSY, m_Ocean_Pos_Y);
	DDV_MinMaxFloat(pDX, m_Ocean_Pos_Y, -255.0, 255.0);
	DDX_Text(pDX, IDC_I_OCEAN_POSZ, m_Ocean_Pos_Z);
	DDV_MinMaxFloat(pDX, m_Ocean_Pos_Z, -255.0, 255.0);
	DDX_Text(pDX, IDC_I_OCEAN_WAVEFREQ, m_Ocean_waveFreq);
	DDV_MinMaxFloat(pDX, m_Ocean_waveFreq, -255.0, 255.0);
	DDX_Text(pDX, IDC_I_OCEAN_WAVEAMP, m_Ocean_waveAmp);
	DDV_MinMaxFloat(pDX, m_Ocean_waveAmp, -255.0, 255.0);
	DDX_Text(pDX, IDC_I_OCEAN_BUMPSCALE, m_Ocean_bumpscale);
	DDV_MinMaxFloat(pDX, m_Ocean_bumpscale, -255.0, 255.0);
	DDX_Text(pDX, IDC_I_OCEAN_BUMPSPEEDX, m_Ocean_bumpSpeed_X);
	DDV_MinMaxFloat(pDX, m_Ocean_bumpSpeed_X, -255.0, 255.0);
	DDX_Text(pDX, IDC_I_OCEAN_BUMPSPEEDY, m_Ocean_bumpSpeed_Y);
	DDV_MinMaxFloat(pDX, m_Ocean_bumpSpeed_Y, -255.0, 255.0);
	
	DDX_Text(pDX, IDC_I_OCEAN_DEEP_R, m_Ocean_DeepColor_R);
	DDV_MinMaxFloat(pDX, m_Ocean_DeepColor_R, 0.0, 1.0);
	DDX_Text(pDX, IDC_I_OCEAN_DEEP_G, m_Ocean_DeepColor_G);
	DDV_MinMaxFloat(pDX, m_Ocean_DeepColor_G, 0.0, 1.0);
	DDX_Text(pDX, IDC_I_OCEAN_DEEP_B, m_Ocean_DeepColor_B);
	DDV_MinMaxFloat(pDX, m_Ocean_DeepColor_B, 0.0, 1.0);
	DDX_Text(pDX, IDC_I_OCEAN_DEEP_A, m_Ocean_DeepColor_A);
	DDV_MinMaxFloat(pDX, m_Ocean_DeepColor_A, 0.0, 1.0);
	
	DDX_Text(pDX, IDC_I_OCEAN_SHALL_R, m_Ocean_shallowcolor_R);
	DDV_MinMaxFloat(pDX, m_Ocean_shallowcolor_R, 0.0, 1.0);
	DDX_Text(pDX, IDC_I_OCEAN_SHALL_G, m_Ocean_shallowcolor_G);
	DDV_MinMaxFloat(pDX, m_Ocean_shallowcolor_G, 0.0, 1.0);
	DDX_Text(pDX, IDC_I_OCEAN_SHALL_B, m_Ocean_shallowcolor_B);
	DDV_MinMaxFloat(pDX, m_Ocean_shallowcolor_B, 0.0, 1.0);
	DDX_Text(pDX, IDC_I_OCEAN_SHALL_A, m_Ocean_shallowcolor_A);
	DDV_MinMaxFloat(pDX, m_Ocean_shallowcolor_A, 0.0, 1.0);
	
	DDX_Text(pDX, IDC_I_OCEAN_REFLE_COLOR_R, m_Ocean_reflectcolor_R);
	DDV_MinMaxFloat(pDX, m_Ocean_reflectcolor_R, 0.0, 1.0);
	DDX_Text(pDX, IDC_I_OCEAN_REFLE_COLOR_G, m_Ocean_reflectcolor_G);
	DDV_MinMaxFloat(pDX, m_Ocean_reflectcolor_G, 0.0, 1.0);
	DDX_Text(pDX, IDC_I_OCEAN_REFLE_COLOR_B, m_Ocean_reflectcolor_B);
	DDV_MinMaxFloat(pDX, m_Ocean_reflectcolor_B, 0.0, 1.0);
	DDX_Text(pDX, IDC_I_OCEAN_REFLE_COLOR_A, m_Ocean_reflectcolor_A);
	DDV_MinMaxFloat(pDX, m_Ocean_reflectcolor_A, 0.0, 1.0);
	
	DDX_Text(pDX, IDC_I_OCEAN_REFLE_AMOUNT, m_Ocean_reflectAmount);
	DDV_MinMaxFloat(pDX, m_Ocean_reflectAmount, -255.0, 255.0);
	DDX_Text(pDX, IDC_I_OCEAN_REFLE_BLUR, m_Ocean_reflectBlur);
	DDV_MinMaxFloat(pDX, m_Ocean_reflectBlur, -255.0, 255.0);
	DDX_Text(pDX, IDC_I_OCEAN_FRESENLPOW, m_Ocean_FresenlPow);
	DDV_MinMaxFloat(pDX, m_Ocean_FresenlPow, -255.0, 255.0);
	DDX_Text(pDX, IDC_I_OCEAN_FRESENLBIAS, m_Ocean_FresenlBias);
	DDV_MinMaxFloat(pDX, m_Ocean_FresenlBias, -255.0, 255.0);
	DDX_Text(pDX, IDC_I_OCEAN_HDRMULTI, m_Ocean_hdrMulti);
	DDV_MinMaxFloat(pDX, m_Ocean_hdrMulti, -255.0, 255.0);

	DDX_Text(pDX, IDC_I_OCEAN_TEXTURE_W, m_Ocean_Texture_W);
	DDV_MinMaxFloat(pDX, m_Ocean_Texture_W, 1, 512);
	DDX_Text(pDX, IDC_I_OCEAN_TEXTURE_H, m_Ocean_Texture_H);
	DDV_MinMaxFloat(pDX, m_Ocean_Texture_H, 1, 512);
}


BEGIN_MESSAGE_MAP(CMenu_Water, CDialog)
	ON_BN_CLICKED(IDC_C_OCEAN_USE, &CMenu_Water::OnBnClickedCOceanUse)
	ON_BN_CLICKED(IDC_C_OCEAN_TRANS, &CMenu_Water::OnBnClickedCOceanTrans)
END_MESSAGE_MAP()


// CMenu_Water message handlers

BOOL CMenu_Water::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	bool init = true;
	((CButton*)GetDlgItem(IDC_C_OCEAN_USE))->SetCheck(init);
	((CButton*)GetDlgItem(IDC_C_OCEAN_TRANS))->SetCheck(init);
	SetControlItem(init);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CMenu_Water::SetControlItem(bool Enable)
{
	((CButton*)GetDlgItem(IDC_I_OCEANSIZE_W))->EnableWindow(false);
	((CButton*)GetDlgItem(IDC_I_OCEANSIZE_H))->EnableWindow(false);

	((CButton*)GetDlgItem(IDC_I_OCEAN_BUMPSCALE))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_BUMPSPEEDX))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_BUMPSPEEDY))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_DEEP_R))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_DEEP_G))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_DEEP_B))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_DEEP_A))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_SHALL_R))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_SHALL_G))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_SHALL_B))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_SHALL_A))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_REFLE_COLOR_R))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_REFLE_COLOR_G))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_REFLE_COLOR_B))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_REFLE_COLOR_A))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_REFLE_AMOUNT))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_REFLE_BLUR))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_FRESENLBIAS))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_HDRMULTI))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_TEXTURE_W))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_TEXTURE_H))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_C_OCEAN_TRANS))->EnableWindow(Enable);
	
	((CButton*)GetDlgItem(IDC_I_OCEAN_WAVEFREQ))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_WAVEAMP))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_FRESENLPOW))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_B_OCEAN_BUMPMAP))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_POSX))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_POSY))->EnableWindow(Enable);
	((CButton*)GetDlgItem(IDC_I_OCEAN_POSZ))->EnableWindow(Enable);
}

void CMenu_Water::OnBnClickedCOceanUse()
{
	// TODO: Add your control notification handler code here
	if(((CButton*)GetDlgItem(IDC_C_OCEAN_USE))->GetCheck())
	{
		g_Option._Ocean._using = true;
		SetControlItem(true);
	}
	else
	{
		g_Option._Ocean._using = false;
		SetControlItem(false);
	}
}

void CMenu_Water::OnBnClickedCOceanTrans()
{
	// TODO: Add your control notification handler code here
	if(((CButton*)GetDlgItem(IDC_C_OCEAN_TRANS))->GetCheck())
	{
		((CButton*)GetDlgItem(IDC_C_OCEAN_TRANS))->SetCheck(true);
		g_Option._Ocean.AlphaLayer = true;
	}
	else
	{
		((CButton*)GetDlgItem(IDC_C_OCEAN_TRANS))->SetCheck(false);
		g_Option._Ocean.AlphaLayer = false;
	}
}


BOOL CMenu_Water::PreTranslateMessage(MSG* pMsg)
{
	// TODO: Add your specialized code here and/or call the base class
	
	if(pMsg->message == WM_KEYDOWN)
	{
		if(pMsg->wParam == VK_ESCAPE) return TRUE;
		if(pMsg->wParam == VK_RETURN) return TRUE;

		this->UpdateData();

		g_Option._Ocean.waveFreq = m_Ocean_waveFreq;
		g_Option._Ocean.waveAmp = m_Ocean_waveAmp;
		g_Option._Ocean.bumpscale = m_Ocean_bumpscale;
		g_Option._Ocean.trxtureScale.x = m_Ocean_Texture_W;
		g_Option._Ocean.trxtureScale.y = m_Ocean_Texture_H;

		if(((CButton*)GetDlgItem(IDC_C_OCEAN_TRANS))->GetCheck())
			g_Option._Ocean.AlphaLayer = true;
		else
			g_Option._Ocean.AlphaLayer = false;

		if(((CButton*)GetDlgItem(IDC_C_OCEAN_USE))->GetCheck())
			g_Option._Ocean._using = true;
		else
			g_Option._Ocean._using = false;

		g_Option._Ocean.bumpspeed.x = m_Ocean_bumpSpeed_X;
		g_Option._Ocean.bumpspeed.y = m_Ocean_bumpSpeed_Y;

		g_Option._Ocean.deepcolor.x = m_Ocean_DeepColor_R;
		g_Option._Ocean.deepcolor.y = m_Ocean_DeepColor_G;
		g_Option._Ocean.deepcolor.z = m_Ocean_DeepColor_B;
		g_Option._Ocean.deepcolor.w = m_Ocean_DeepColor_A;

		g_Option._Ocean.shallowcolor.x = m_Ocean_shallowcolor_R;
		g_Option._Ocean.shallowcolor.y = m_Ocean_shallowcolor_G;
		g_Option._Ocean.shallowcolor.z = m_Ocean_shallowcolor_B;
		g_Option._Ocean.shallowcolor.w = m_Ocean_shallowcolor_A;

		g_Option._Ocean.reflectcolor.x = m_Ocean_reflectcolor_R;
		g_Option._Ocean.reflectcolor.y = m_Ocean_reflectcolor_G;
		g_Option._Ocean.reflectcolor.z = m_Ocean_reflectcolor_B;
		g_Option._Ocean.reflectcolor.w = m_Ocean_reflectcolor_A;

		g_Option._Ocean.reflactamount = m_Ocean_reflectAmount;
		g_Option._Ocean.reflactblur = m_Ocean_reflectBlur;
		g_Option._Ocean.fresenlpow = m_Ocean_FresenlPow;
		g_Option._Ocean.fresenlbias = m_Ocean_FresenlBias;
		g_Option._Ocean.hdrMulti = m_Ocean_hdrMulti;

		g_Option._Ocean.OceanSize_W = m_OceanMap_Width;
		g_Option._Ocean.OceanSize_H = m_OceanMap_Height;

		g_Option._Ocean.Position.x = m_Ocean_Pos_X;
		g_Option._Ocean.Position.y = m_Ocean_Pos_Y;
		g_Option._Ocean.Position.z = m_Ocean_Pos_Z;
	}	
	
	return CDialog::PreTranslateMessage(pMsg);
}
