// TestingMFC_3DView.cpp : implementation of the CTestingMFC_3DView class
//

#include "stdafx.h"
#include "TestingMFC_3D.h"

#include "TestingMFC_3DDoc.h"
#include "TestingMFC_3DView.h"
#include "Shader/Shader_Water.h"
#include "Shader/camera.h"
#include "CG/CG_Ocean.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


LPDIRECT3D9             g_pD3D          = NULL;
LPDIRECT3DDEVICE9       m_pD3DDevice    = NULL;
LPDIRECT3DTEXTURE9		m_Texture_SkyBox_Top;

CG_Ocean water;
//Shader_Water water;
// CTestingMFC_3DView

IMPLEMENT_DYNCREATE(CTestingMFC_3DView, CView)

BEGIN_MESSAGE_MAP(CTestingMFC_3DView, CView)
END_MESSAGE_MAP()

// CTestingMFC_3DView construction/destruction

CTestingMFC_3DView::CTestingMFC_3DView()
{
	// TODO: add construction code here

}

CTestingMFC_3DView::~CTestingMFC_3DView()
{
    if( m_pD3DDevice != NULL )
        m_pD3DDevice->Release();

    if( g_pD3D != NULL )
        g_pD3D->Release();
}

BOOL CTestingMFC_3DView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}


// CTestingMFC_3DView diagnostics

#ifdef _DEBUG
void CTestingMFC_3DView::AssertValid() const
{
	CView::AssertValid();
}

void CTestingMFC_3DView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CTestingMFC_3DDoc* CTestingMFC_3DView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTestingMFC_3DDoc)));
	return (CTestingMFC_3DDoc*)m_pDocument;
}
#endif //_DEBUG


// CTestingMFC_3DView message handlers

void CTestingMFC_3DView::OnInitialUpdate()
{
	CView::OnInitialUpdate();

	// TODO: Add your specialized code here and/or call the base class
	HWND g_hWnd = GetSafeHwnd();
	g_pD3D = Direct3DCreate9( D3D_SDK_VERSION );

    D3DDISPLAYMODE d3ddm;

    g_pD3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT, &d3ddm );

    D3DPRESENT_PARAMETERS d3dpp;
    ZeroMemory( &d3dpp, sizeof(d3dpp) );

    d3dpp.Windowed               = TRUE;
    d3dpp.SwapEffect             = D3DSWAPEFFECT_DISCARD;
    d3dpp.BackBufferFormat       = d3ddm.Format;
    d3dpp.EnableAutoDepthStencil = TRUE;
    d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
    d3dpp.PresentationInterval   = D3DPRESENT_INTERVAL_IMMEDIATE;

    g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, g_hWnd,
                          D3DCREATE_SOFTWARE_VERTEXPROCESSING,
                          &d3dpp, &m_pD3DDevice );

	
	//
	// Normally we would need to turn lighting off in a simple sample like 
	// this, but this time I've opted to let the effect file to do it for us. 
	// This is one of the benefits of using an effect file; it lets us batch 
	// together all the state changes necessary to create the "effect". This 
	// makes it easier for other programmers to use our effect as it cuts 
	// down on the amount of Direct3D code that has to be added to their code 
	// before the effect will work as intended. In essence, an effect file is 
	// a way of scripting complex render-state changes, which would normally 
	// require the addition of compiled code.
	//

	//m_pD3DDevice->SetRenderState( D3DRS_LIGHTING, FALSE );
	
	m_pD3DDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );
	D3DXMATRIXA16 g_matProj;

	D3DXMatrixPerspectiveFovLH( &g_matProj, D3DXToRadian( 45.0f ), 
                                640.0f / 480.0f, 0.1f, 100.0f );
    m_pD3DDevice->SetTransform( D3DTS_PROJECTION, &g_matProj );

	D3DXCreateTextureFromFile( m_pD3DDevice, L"CG/test2.jpg", &m_Texture_SkyBox_Top );

	water.Init(m_pD3DDevice, D3DXVECTOR3(0,-5,0), 1000, 1000, L"CG/waves2.dds", &m_Texture_SkyBox_Top);
/*	camera_info a;
	a.pos = D3DXVECTOR3(-27,8,0);
	a.rotx = 0;
	a.roty = 0;
	a.rotz = 0;
	a.fov = 45;
	a.aspect = 1.33;
	a.nearz = 0.3;
	a.farz = 5000.0;
	water.Init(m_pD3DDevice, D3DXVECTOR3(0,-5,0), 1000, 1000, L"Data/Water/terrain.png", L"CG/SkyBox_Top.jpg", a);
	*/
}

void CTestingMFC_3DView::OnDraw(CDC* /*pDC*/)
{
	CTestingMFC_3DDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	static TCHAR FrameRate[ 50 ];
    static TCHAR TitleBuffer[ 255 ];
	// TODO: add draw code for native data here

	D3DXMATRIX Rx, Ry;

	static float x = 0.0f;
	D3DXMatrixRotationX(&Rx, x);

	// incremement y-rotation angle each frame
	static float y = 0.0f;
	D3DXMatrixRotationY(&Ry, y);
	
	static UCHAR pKeyBuffer[ 256 ];
    // Retrieve keyboard state
    if ( !GetKeyboardState( pKeyBuffer ) ) return;

    // Check the relevant keys
    if ( pKeyBuffer[ VK_UP    ] & 0xF0 ) y+=0.01f;
    if ( pKeyBuffer[ VK_DOWN  ] & 0xF0 ) y-=0.01f;
    if ( pKeyBuffer[ VK_LEFT  ] & 0xF0 ) x-=0.01f;
    if ( pKeyBuffer[ VK_RIGHT ] & 0xF0 ) x+=0.01f;
   
	// combine x- and y-axis rotation transformations.
	D3DXMATRIX p = Rx * Ry;
	m_pD3DDevice->SetTransform(D3DTS_VIEW, &p);

	m_pD3DDevice->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,
                         D3DCOLOR_COLORVALUE(0.0f,0.0f,1.0f,1.0f), 1.0f, 0 );
	{
		m_pD3DDevice->BeginScene();
		
		water.Rander(D3DXVECTOR3(x,1,y));

		CWnd *pWnd = AfxGetMainWnd();
		HWND hwnd = pWnd->m_hWnd;

		_stprintf( TitleBuffer, _T("Camera position X, Y : (%f, %f)"), x, y);
		pWnd->SetWindowTextW( TitleBuffer );
	}
	m_pD3DDevice->EndScene();
    m_pD3DDevice->Present( NULL, NULL, NULL, NULL );

	this->Invalidate(0);
}